#include <Cell.h>
#include <Print.h>

using namespace ZSET;

VECTOR CELL::if_in(VECTOR r)
{
  if (r.size() != r0.size())
    ERROR("Incompatible dimensions");
  VECTOR result(r.size(),0.);
  
  if (r.size() == 2)
  {
    for (int i = 0; i < r.size(); i++)
    {
      if (r[i] > r0[i]+size[i])
	result[i] = 1.;
      else if (r[i] < r0[i])
	result[i] = -1.;
    }
  }
  else
    ERROR("Not implemented yet");  

  return result;
}
LIST<int> CELL::get_neighbours()
{
  prn("get_neighbours ", neighbours);
  return neighbours;
}
int CELL::find_neighbour(VECTOR v)
{
  for (int i = 0; i < vectors.size(); i++)
  {
    if (vectors[i] == v)
      return neighbours[i];
  }
  return -1;
}
STRING CELL::string_cell_type()
{
  if (position == MID_2D)
	return "MID_2D";
  else if (position == LEFT_2D)
	return "LEFT_2D";
  else if (position == RIGHT_2D)
	return "RIGHT_2D";
  else if (position ==TOP_2D)
	return "TOP_2D";
  else if (position == BOT_2D)
	return "BOT_2D";
  else if (position == TOP_RIGHT_2D)
	return "TOP_RIGHT_2D";
  else if (position == TOP_LEFT_2D)
	return "TOP_LEFT_2D";
  else if (position == BOT_RIGHT_2D)
	return "BOT_RIGHT_2D";
  else if (position == BOT_LEFT_2D)
	return "BOT_LEFT_2D";
  else
    return "unknown cell type";
}




