#ifndef __CELL__
#define __CELL__

#include <List.h>
#include <Particle.h>
#include <Print.h>

namespace ZSET {
  using namespace ZSET;

enum CELL_POSITION {MID_2D, LEFT_2D, RIGHT_2D, TOP_2D, BOT_2D, TOP_RIGHT_2D, TOP_LEFT_2D, BOT_RIGHT_2D, BOT_LEFT_2D,
	            MID_3D, ddd3D};

class CELL
{
protected:
  LIST<int> neighbours;
  LIST<VECTOR> vectors;
public:
  LIST<PARTICLE*> particles;
  VECTOR r0, size;
  bool checked; 
  int Nx,Ny,Nz;
  CELL_POSITION position;
  

  CELL(VECTOR r, VECTOR s, int nx, int ny, int nz, CELL_POSITION pos, LIST<int> n, LIST<VECTOR> v) {r0 = r; size = s; checked=FALSE; Nx = nx; Ny = ny; Nz = nz; position = pos; neighbours = n; vectors = v;}
  CELL() {}
 ~CELL() {} 
  
  VECTOR if_in(VECTOR r);
  LIST<int> get_neighbours();
  void add_neighbour(int n) { neighbours.add(n); }
  void add_vector(VECTOR v) { vectors.add(v); }
  void add_vector(double vi, double vj) { VECTOR v(2); v[0] = vi; v[1] = vj; vectors.add(v); }
  void add_vector(double vi, double vj, double vk) { VECTOR v(3); v[0] = vi; v[1] = vj; v[2] = vk; vectors.add(v); }
  int  find_neighbour(VECTOR v);
  STRING string_cell_type();
};

} 

#endif
