#include <MD_Material.h>
#include <Print.h>
#include <math.h>

using namespace ZSET;

MD_MATERIAL::MD_MATERIAL(int i, STRING str)
{ 
  id = i;
  name = str; 
  if (str == LJ) 
    material_parameter.resize(2);
  else if (str == CONTACT) 
    material_parameter.resize(3);
  else 
   ERROR("Unknown potential <"+str+">"); 
}
void MD_MATERIAL::print()
{
    int i;

    prn("mat->id = ", id);
    prn("mat->name = "+ name);
    prn("mat->color = ", color);
    for (i = 0; i < material_parameter.size(); i++)
      prn("mat->m["+itoa(i)+"] = ", material_parameter[i]);
}
void MD_MATERIAL::set_multiplier(MULTIPLIERS m)
{
  if (m.name == LJ)
  {
    multiplier.name = m.name;
    multiplier.length = m.length;
    multiplier.mass = m.mass;
    multiplier.energy = m.energy;
    multiplier.time = m.time;
    multiplier.velocity = m.velocity;
    multiplier.force = m.force;
    multiplier.pressure = m.pressure;
    multiplier.temperature = m.temperature;
  }
  else
   ERROR("Unknown potential <"+m.name+">");

}
void MD_MATERIAL::set_multiplier()
{
   if (name == LJ)
   {
     multiplier.name = name; 
     multiplier.length = material_parameter[1];
     multiplier.mass = mass;
     multiplier.energy = material_parameter[0];
     multiplier.time = sqrt(pow(multiplier.length,2.)*multiplier.mass/multiplier.energy);
     multiplier.velocity = sqrt(multiplier.energy/multiplier.mass);
     multiplier.force = multiplier.energy/multiplier.length;
     multiplier.pressure = multiplier.energy/pow(multiplier.length,double(dim));
     multiplier.temperature = multiplier.energy/kB;
   }
   //else 
   //  ERROR("Unknown potential <"+name+">");
}
void MD_MATERIAL::scale_parameters()
{
   if (name == LJ)
   {
/*
     multiplier.length = material_parameter[1];
     multiplier.mass = mass;
     multiplier.energy = material_parameter[0];
     multiplier.time = sqrt(pow(multiplier.length,2.)*multiplier.mass/multiplier.energy);
     multiplier.velocity = sqrt(multiplier.energy/multiplier.mass);
     multiplier.force = multiplier.energy/multiplier.length;
     multiplier.pressure = multiplier.energy/pow(multiplier.length,double(dim));
     multiplier.temperature = multiplier.energy/kB;
*/

     mass /= multiplier.mass;
     material_parameter[0] /= multiplier.energy;
     material_parameter[1] /= multiplier.length;
   }
  // else
  //   ERROR("Unknown potential <"+name+">");
}
